/*
 * GOATTRACKER reSID interface
 */

#include <stdlib.h>

#include "sid.h"
#include "gsound.h"

SID *sid;

extern "C" {

/* "Our" SID registers */
/* Note: these are more than 8bit to detect carry flag easily in C code :-) */
int sidreg[32];

void sid_init(int speed);
int sid_fillbuffer(short *ptr, int samples);
void sid_dumpregs(void);

void sid_init(int speed)
{
  int c;

  sid = new SID;
  sid->set_sampling_parameters(985248, SAMPLE_FAST, speed, 20000);
  sid->reset();
  for (c = 0; c <= 0x18; c++)
  {
    sidreg[c] = 0x00;
  }
}

int sid_fillbuffer(short *ptr, int samples)
{
  int tdelta = 985248 / FRAMERATE;
  return sid->clock(tdelta, ptr, samples);
}

void sid_dumpregs(void)
{
  int c;
  for (c = 0; c <= 0x18; c++)
  {
    sid->write(c, sidreg[c]);
  }
}

}
